/*
 * U3Cheat.c
 */

#include "alerts.h"
#include "datatypes.h"
#include "roster.h"
#include "mystring.h"

#define iName		3
#define iHealth		4
#define iStr		5
#define iDex		6
#define iInt		7
#define iWis		8
#define iRace		9
#define iClass		10
#define iSex		11
#define iCurMP		12
#define iCurHP		13
#define iMaxHP		14
#define iXP			15
#define iFood		16
#define iGold		17
#define iGems		18
#define iKeys		19
#define iPowders	20
#define iEqArm		21
#define iArmor		22
#define iAQty		23
#define iEqWeap		24
#define iWeapons	25
#define iWQty		26
#define iTorches	51
#define iForce		53
#define iFire		54
#define iSnake		55
#define iKings		56

#define kNamStrLen	13 /* 12 + 1 */

FSSpec spec;
short AQty[16];
short WQty[16];
Boolean dirty = false;

void WitchChant(void);
Boolean GetFile(FSSpec *spec);
Boolean DoRosterDialog();
void SetUpRosterDialog(DialogPtr d);
pascal Boolean RosterFilterProc(DialogPtr d, EventRecord *e, short *itemHit);
short FindActiveRadio(DialogPtr d);
short FindControlsIdx(DialogPtr d, Handle c);
void SetRadio(DialogPtr d, short item);
void DoEditDialog(short id);
void SetUpEditDialog(DialogPtr d,short id);
void CopyEditDialog(DialogPtr d,short id);
void HiliteRosterControls(DialogPtr d, short val);
void SetNearestRadio(DialogPtr d, short item, short countBy,short hOrV);
pascal Boolean EditFilterProc(DialogPtr d, EventRecord *e, short *itemHit);
Boolean ValidateEditDialog(DialogPtr d);

pascal OSErr SetDialogTrackCursor (DialogPtr theDialog,
	Boolean tracks) = {0x303C,0x0306,0xAA68};



main()
{
	OSErr err;
	
	WitchChant();
	
	MaxApplZone();
	MoreMasters();	MoreMasters();	MoreMasters();	MoreMasters();
	
	if (GetFile(&spec)) {
		err = LoadRoster(&spec);
		if (err == noErr) {
			DoRosterDialog();
		} else {
			DoError("\pError loading Roster file!",err,false);
		}
			
	}
} 

void WitchChant(void)
{
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
}

Boolean GetFile(FSSpec *spec)
{
	SFTypeList typeList;
	StandardFileReply reply;
	
	typeList[0] = 'RSTR';
	StandardGetFile(nil, 1, typeList, &reply);
	
	
	*spec = reply.sfFile;
	return (reply.sfGood);
}

Boolean DoRosterDialog()
{
	DialogPtr d;
	Boolean done = false;
	short itemHit,ync,id;
	OSErr err;
	char cname[13];
	Str255 pname;
	short iType;
	Handle iHandle;
	Rect iRect;
	
	
	d = GetNewDialog(130,0L,(WindowPtr)-1);
	if (!d) DoError("\pCan't Load Dialog!!",0,true);

	SetUpRosterDialog(d);
	(void) SetDialogDefaultItem(d, 1);

	ShowWindow(d);
	SetPort(d);		
	DrawDefaultButton(d);
	
	while (!done) {
		DrawDefaultButton(d);
		//GetDItem(d,1,&iType,&iHandle,&iRect);
		//HiliteControl((ControlHandle)iHandle,0);
		ModalDialog(RosterFilterProc,&itemHit);
		
		switch (itemHit) {
		case 1:
			id = FindActiveRadio(d) - 4;
			HiliteRosterControls(d,255);
			DoEditDialog(id);
			HiliteRosterControls(d,0);

			NameOut(id,cname);
			C2PString(cname,pname);
			GetDItem(d,id+4,&iType,&iHandle,&iRect);
			SetCTitle((ControlHandle)iHandle,pname);
			break;
		case 3:
			if (!dirty) {
				ync=3;
			} else {
				ync = SaveChanges();
			}
			if (ync == 2) break;// cancel
			done = true;
			if (ync == 3) break; // don't save
			// fall through - save
		case 2:
			err = SaveRoster(&spec);
			if (err != noErr) {
				DoError("\pError saving Roster file!",err,false);
			}
			dirty=false;
			break;
		default:
			;
		}
	}
	DisposeDialog(d);
}

void SetUpRosterDialog(DialogPtr d)
{
	short id;
	char cname[kNamStrLen];
	Str255 pname;
	
	short iType;
	Handle iHandle;
	Rect iRect;
	
	for (id=0; id<20;id++) {
		NameOut(id,cname);
		if (cname[0]) {
			C2PString(cname,pname);
			GetDItem(d,id+4,&iType,&iHandle,&iRect);
			SetCTitle((ControlHandle)iHandle,pname);
		} else {
			GetDItem(d,id+4,&iType,&iHandle,&iRect);
			SetCTitle((ControlHandle)iHandle,"\p<Empty>");
			HiliteControl((ControlHandle)iHandle,255); //(dim control)
		}
	}	
	
	// prime our radio buttons.
	//GetDItem(d,4,&iType,&iHandle,&iRect);
	//SetCtlValue((ControlHandle)iHandle,1);
	SetNearestRadio(d,4,1,0);
	if (FindActiveRadio(d) < 0) {
		GetDItem(d,1,&iType,&iHandle,&iRect);
		HiliteControl((ControlHandle)iHandle,255); //(dim control)
		GetDItem(d,2,&iType,&iHandle,&iRect);
		HiliteControl((ControlHandle)iHandle,255); //(dim control)
	}
}

#define kEnterKey		3
#define kReturnKey		13
#define kEscapeKey		27
#define kLeftKey		28
#define kRightKey		29
#define kUpKey			30
#define kDownKey		31

pascal Boolean RosterFilterProc(DialogPtr d, EventRecord *e, short *itemHit)
{
	char 	theChar;
	short	num, i, iType;
	Handle	iHandle;
	Rect	iRect;
	Str255	iText;
	short 	radio;
	Point	where;
	OSErr err;
	
	ModalFilterUPP	stdFilterProc;
	Boolean ret;

	unsigned long DoubleTime = GetDblTime();	

	static	long	lastWhen = 0;
	static	short	lastControl=0;	
	
	switch(e->what) {
	case keyDown:
	case autoKey:		
		theChar = (e->message & charCodeMask);
		
		switch(theChar){
		case kReturnKey:
		case kEnterKey:
		case 'e':
		case 'E':
			GetDItem(d, 1, &iType, &iHandle, &iRect);
			if ((*(ControlHandle)iHandle)->contrlHilite == 255) break;
			
			FlashButton((ControlHandle)iHandle);
			*itemHit = 1;
			return (true);
			break; //unreachable code
		case '.':
			if (!(e->modifiers & cmdKey))
				break;
			// else Fall Through!	
		case kEscapeKey:
		case 'Q':
		case 'q':
			GetDItem(d, 3, &iType, &iHandle, &iRect);
			if (iType == ctrlItem + btnCtrl) {		// If there is a Button
				FlashButton((ControlHandle)iHandle);
			
				*itemHit = 3;
				return (true);
			//} else {
			//	return (false);
			}
			break; // duh!!
		case 's':
		case 'S':
			GetDItem(d, 2, &iType, &iHandle, &iRect);
			if ((*(ControlHandle)iHandle)->contrlHilite == 255) break;
			FlashButton((ControlHandle)iHandle);
		
			*itemHit = 2;
			return (true);
			break; // duh!!
		case kUpKey:
			radio = FindActiveRadio(d) - 1;
			if (radio < 1) break;
			
			if (radio < 4) radio = 23;
			//SetRadio(d,radio);
			SetNearestRadio(d,radio,-1,0);
			break;
		case kDownKey:
			radio = FindActiveRadio(d) + 1;
			if (radio < 1) break;
			if (radio > 23) radio = 4;
			//SetRadio(d,radio);
			SetNearestRadio(d,radio,1,0);
			break;
		case kLeftKey:
			radio=FindActiveRadio(d);
			if (radio < 1) break;
			if (radio>13) {
				radio -= 10;
			} else {
				if (radio == 4) {
					radio = 23;
				} else {
					radio += 9;
				}
			}
			//SetRadio(d,radio);
			SetNearestRadio(d,radio,-1,1);			
			break;
		case kRightKey:
			radio=FindActiveRadio(d);
			if (radio < 1) break;
			if (radio<14) {
				radio += 10;
			} else {
				if (radio == 23) {
					radio = 4;
				} else {
					radio -= 9;
				}
			}
			//SetRadio(d,radio);
			SetNearestRadio(d,radio,1,1);
			break;
		default:
			;
		} // switch (theChar){
	break;
	case mouseDown:
		where = e->where;
		GlobalToLocal(&where);
		if (FindControl(where,d,(ControlHandle*)(&iHandle))) {	// is control?
			if (i = FindControlsIdx(d,iHandle)) {				// is radio control?
				if (TrackControl((ControlHandle)iHandle, where, nil)) { // good hit?
					if ( ( (e->when - lastWhen) < DoubleTime ) 
						&& (i == lastControl)) {		// is double click?
						// DoubleClick
						*itemHit = 1;
						return (true);
					} // if e->when
					lastWhen = e->when;					// is single click.
					lastControl = i;
				
					SetRadio(d,i);			// set Radio Control.
					e->what = nullEvent; 	// abort event
					return (false);
				} // if TrackControl
			} // if FindControlsIdx
		} // if FindControl
		break;
	default:
		;
	}	// switch (e->what)
	//return (false);
	err = GetStdFilterProc(&stdFilterProc);
	if (err == noErr) ret = (stdFilterProc)(d,e,itemHit);
	else ret = false;
	
	return ret;
}

void HiliteRosterControls(DialogPtr d, short val)
{
	short i,iType;
	Handle iHandle;
	Rect iRect;
	
	for (i=1;i<4;i++) {
		GetDItem(d,i,&iType,&iHandle,&iRect);
		HiliteControl((ControlHandle)iHandle,val);
	}
}

short FindActiveRadio(DialogPtr d)
{
	short i,iType;
	Handle iHandle;
	Rect iRect;
	
	for (i=4;i<=23;i++) {
		GetDItem(d,i,&iType,&iHandle,&iRect);
		if (GetCtlValue((ControlHandle)iHandle) == 1)
			break;
	}
	if (i == 24) i = -1;
	
	return i;
}

short FindControlsIdx(DialogPtr d, Handle c)
{
	short i,iType;
	Handle iHandle;
	Rect iRect;
	
	for (i=4;i<=23;i++) {
		GetDItem(d,i,&iType,&iHandle,&iRect);
		if (c == iHandle)
			break;
	}
	if (i == 24) i = 0;
	
	return i;
}

void SetNearestRadio(DialogPtr d, short item, short countBy,short horv)
{
	short i,iType,val,c,realItem;
	Handle iHandle;
	Rect iRect;

	if (horv == 0) { // if Vertical
		realItem = item;
		for (c=0;c < 20;c++) {
			GetDItem(d,realItem,&iType,&iHandle,&iRect);
			if ((*(ControlHandle)iHandle)->contrlHilite == 255) {
				realItem = realItem + countBy;
				if (realItem > 23) realItem = 4;
				if (realItem < 4) realItem = 23;
			} else {
				break;
			}
		}
	} else { // if Horizontal
		realItem = item;
		for (c=0;c < 20;c++) {
			GetDItem(d,realItem,&iType,&iHandle,&iRect);
			if ((*(ControlHandle)iHandle)->contrlHilite == 255) {
				if (countBy<0) { // going left
					if (realItem>13) {
						realItem -= 10;
					} else {
						if (realItem == 4) {
							realItem = 23;
						} else {
							realItem += 9;
						}
					}
				} else { //going right 
					if (realItem<14) {
						realItem += 10;
					} else {
						if (realItem == 23) {
							realItem = 4;
						} else {
							realItem -= 9;
						}
					}
				}
			} else {
				break;
			}
		}
	}
	if (c == 20) realItem = 0; // set NONE!!

	SetRadio(d,realItem);
}

void SetRadio(DialogPtr d, short item)
{
	short i,iType,val;
	Handle iHandle;
	Rect iRect;

	for (i=4;i<=23;i++) {
		GetDItem(d,i,&iType,&iHandle,&iRect);
		val = (i == item) ? 1 : 0;
		SetCtlValue((ControlHandle)iHandle, val);
	}
}

void DoEditDialog(short id)
{
	DialogPtr d;
	GrafPtr	savePort;
	short itemHit;
	Boolean done = false;
	short lastArmor = 0;
	short lastWeapon = 0;
	short iType;
	Handle iQty,iHandle;
	Rect iRect;
	Str255 str;
	long num;
	Boolean goodData;
	
	GetPort(&savePort);
	
	d = GetNewDialog(131,0L,(WindowPtr)-1L);
	if (!d) DoError("\pCan't Load Dialog!!",0,true);
	
	ShowWindow(d);
	SetPort(d);
	
	SetUpEditDialog(d,id);
	
	(void)SetDialogDefaultItem(d,1);
	(void)SetDialogCancelItem(d,2);
	(void)SetDialogTrackCursor(d, true);	
	
	while (!done) {
		DrawDefaultButton(d);
		
		ModalDialog(EditFilterProc,&itemHit);
		
		switch (itemHit) {
		case 1:
			goodData = ValidateEditDialog(d);
			if (!goodData) break;
			
			CopyEditDialog(d,id);
			dirty = true;
			// fall through
		case 2:
			done = true;
			break;
		case iArmor:
			GetDItem(d,iAQty,&iType,&iQty,&iRect);
			GetIText(iQty,str);
			StringToNum(str,&num);
			AQty[lastArmor] = (short) num;
			
			GetDItem(d,iArmor,&iType,&iHandle, &iRect);
			lastArmor = GetCtlValue((ControlHandle)iHandle)-1;
			
			NumToString((long)AQty[lastArmor],str);
			SetIText(iQty,str);
			break;
		case iWeapons:
			GetDItem(d,iWQty,&iType,&iQty,&iRect);
			GetIText(iQty,str);
			StringToNum(str,&num);
			WQty[lastWeapon] = (short) num;
			
			GetDItem(d,iWeapons,&iType,&iHandle, &iRect);
			lastWeapon = GetCtlValue((ControlHandle)iHandle)-1;
			
			NumToString((long)WQty[lastWeapon],str);
			SetIText(iQty,str);
			break;
		case iForce:
			GetDItem(d,iForce,&iType,&iHandle,&iRect);
			SetCtlValue((ControlHandle)iHandle,!GetCtlValue((ControlHandle)iHandle));
			break;
		case iFire:
			GetDItem(d,iFire,&iType,&iHandle,&iRect);
			SetCtlValue((ControlHandle)iHandle,!GetCtlValue((ControlHandle)iHandle));
			break;
		case iSnake:
			GetDItem(d,iSnake,&iType,&iHandle,&iRect);
			SetCtlValue((ControlHandle)iHandle,!GetCtlValue((ControlHandle)iHandle));
			break;
		case iKings:
			GetDItem(d,iKings,&iType,&iHandle,&iRect);
			SetCtlValue((ControlHandle)iHandle,!GetCtlValue((ControlHandle)iHandle));
			break;
		default:
			;
		}
	}
	
	SetPort(savePort);
	DisposeDialog(d);
}

pascal Boolean EditFilterProc(DialogPtr d, EventRecord *e, short *itemHit)
{
	char 	theChar;
	short	item;
	DialogRecord *dr;
	OSErr err;
	
	short iType;
	Handle iHandle;
	Rect iRect;
	Str255 iText;
	TEHandle teh;
	Boolean selectedText;
	
	ModalFilterUPP	stdFilterProc;
	Boolean ret;
	
	switch(e->what) {
	case keyDown:
	case autoKey:
		if (e->modifiers & cmdKey) break;
		theChar = (e->message & charCodeMask);
		dr = (DialogRecord *)d;
		item = dr->editField+1;
		teh = dr->textH;
		selectedText=!(!((*teh)->selEnd - (*teh)->selStart));
		
		switch (item) {
		case iName:
			GetDItem(d,item,&iType,&iHandle,&iRect);
			GetIText(iHandle,iText);
			if (iText[0] >= 12) { // if the name is 12 long ... 
				if ((theChar < 32) || (theChar == 0xFF) || selectedText) break; 
				SysBeep(3);
				e->what = nullEvent; 	// abort event
				return (false);
			}
			break;
		case iStr:
		case iDex:
		case iInt:
		case iWis:
		case iCurMP:
		case iGems:
		case iKeys:
		case iPowders:
		case iTorches:
		case iWQty:
		case iAQty:
			GetDItem(d,item,&iType,&iHandle,&iRect);
			GetIText(iHandle,iText);
			if (iText[0] >= 3) {
				if ((theChar < 32) || (theChar == 0xFF) || selectedText) goto evil;
				SysBeep(3);
				e->what = nullEvent; 	// abort event
				return (false);
			}
			// fall through; 
		case iFood:
		case iXP:
		case iCurHP:
		case iMaxHP:
		case iGold:
			// the little numbers will survive the first check fine ... 
			GetDItem(d,item,&iType,&iHandle,&iRect);
			GetIText(iHandle,iText);
			if (iText[0] >= 5) {
				if ((theChar < 32) || (theChar == 0xFF) || selectedText) goto evil; 
				SysBeep(3);
				e->what = nullEvent; 	// abort event
				return (false);
			}
evil:			//all numbers are evil!
			if ((theChar < '0') || (theChar>'9')) {
				if ((theChar < 32) || (theChar == 0xFF)) break; 
				SysBeep(3);
				e->what = nullEvent; 	// abort event
				return (false);
			}
		}
	}
	
	err = GetStdFilterProc(&stdFilterProc);
	if (err == noErr) ret = (stdFilterProc)(d,e,itemHit);
	else ret = false;
	
	return ret;
}


void SetUpEditDialog(DialogPtr d,short id)
{
	Str255 name,str;
	short iType,i;
	Handle iHandle;
	Rect iRect;
	char tempname[kNamStrLen];
	
	NameOut(id,tempname);
	C2PString(tempname,name);
	GetDItem(d,iName,&iType,&iHandle, &iRect);
	SetIText(iHandle,name);
	SelIText(d,iName,0,32767);
	
	GetDItem(d,iHealth,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,HealthOut(id));
	
	GetDItem(d,iStr,&iType,&iHandle, &iRect);
	NumToString((long)StrOut(id),str);
	SetIText(iHandle,str);
	
	GetDItem(d,iDex,&iType,&iHandle, &iRect);
	NumToString((long)DexOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iInt,&iType,&iHandle, &iRect);
	NumToString((long)IntOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iWis,&iType,&iHandle, &iRect);
	NumToString((long)WisOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iRace,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,RaceOut(id));

	GetDItem(d,iClass,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,ClassOut(id));

	GetDItem(d,iSex,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,SexOut(id));

	GetDItem(d,iCurMP,&iType,&iHandle, &iRect);
	NumToString((long)CurMPOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iCurHP,&iType,&iHandle, &iRect);
	NumToString((long)CurHPOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iMaxHP,&iType,&iHandle, &iRect);
	NumToString((long)MaxHPOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iXP,&iType,&iHandle, &iRect);
	NumToString((long)XPOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iFood,&iType,&iHandle, &iRect);
	NumToString((long)FoodOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iGold,&iType,&iHandle, &iRect);
	NumToString((long)GoldOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iTorches,&iType,&iHandle, &iRect);
	NumToString((long)TorchesOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iGems,&iType,&iHandle, &iRect);
	NumToString((long)GemsOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iKeys,&iType,&iHandle, &iRect);
	NumToString((long)KeysOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iPowders,&iType,&iHandle, &iRect);
	NumToString((long)PowdersOut(id),str);
	SetIText(iHandle,str);

	GetDItem(d,iEqArm,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,EqArmOut(id));

	GetDItem(d,iArmor,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,1);
	
	for (i=0; i<7; i++) {
		AQty[i] = ArmOut(id,i);
	}
	GetDItem(d,iAQty,&iType,&iHandle, &iRect);
	NumToString((long)AQty[0],str);
	SetIText(iHandle,str);

	GetDItem(d,iEqWeap,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,EqWeapOut(id));

	GetDItem(d,iWeapons,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,1);
	
	for (i=0; i<15; i++) {
		WQty[i] = WeapOut(id,i);
	}
	GetDItem(d,iWQty,&iType,&iHandle, &iRect);
	NumToString((long)WQty[0],str);
	SetIText(iHandle,str);
	
	GetDItem(d,iForce,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,ForceOut(id));
	
	GetDItem(d,iFire,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,FireOut(id));

	GetDItem(d,iSnake,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,SnakeOut(id));

	GetDItem(d,iKings,&iType,&iHandle, &iRect);
	SetCtlValue((ControlHandle)iHandle,KingsOut(id));
}

void CopyEditDialog(DialogPtr d,short id)
{
	Str255 name,str;
	char tempname[kNamStrLen];
	short iType,i;
	Handle iHandle;
	Rect iRect;
	long num;
	
	GetDItem(d,iName,&iType,&iHandle, &iRect);
	GetIText(iHandle,name);
	if (name[0] > 12) name[0] = 12;
	P2CString(name,tempname);
	NameIn(id,tempname);
	
	GetDItem(d,iHealth,&iType,&iHandle, &iRect);
	HealthIn(id,GetCtlValue((ControlHandle)iHandle));
	
	GetDItem(d,iStr,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	StrIn(id,(short)num);
	
	GetDItem(d,iDex,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	DexIn(id,(short)num);

	GetDItem(d,iInt,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	IntIn(id,(short)num);

	GetDItem(d,iWis,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	WisIn(id,(short)num);

	GetDItem(d,iRace,&iType,&iHandle, &iRect);
	RaceIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iClass,&iType,&iHandle, &iRect);
	ClassIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iSex,&iType,&iHandle, &iRect);
	SexIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iCurMP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	CurMPIn(id,(short)num);

	GetDItem(d,iCurHP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	CurHPIn(id,(short)num);

	GetDItem(d,iMaxHP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	MaxHPIn(id,(short)num);

	GetDItem(d,iXP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	XPIn(id,(short)num);

	GetDItem(d,iFood,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	FoodIn(id,(short)num);

	GetDItem(d,iGold,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	GoldIn(id,(short)num);

	GetDItem(d,iTorches,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	TorchesIn(id,(short)num);

	GetDItem(d,iGems,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	GemsIn(id,(short)num);

	GetDItem(d,iKeys,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	KeysIn(id,(short)num);

	GetDItem(d,iPowders,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	PowdersIn(id,(short)num);

	GetDItem(d,iEqArm,&iType,&iHandle, &iRect);
	EqArmIn(id,GetCtlValue((ControlHandle)iHandle));

	/*GetDItem(d,iArmor,&iType,&iHandle, &iRect);
	i = GetCtlValue((ControlHandle)iHandle)-1;
	
	// File the last Armor Value, to be sure.
	GetDItem(d,iAQty,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	AQty[i] = (short) num;*/

	for (i=0; i<7; i++) {
		ArmIn(id,i,(char)AQty[i]);
	}

	GetDItem(d,iEqWeap,&iType,&iHandle, &iRect);
	EqWeapIn(id,GetCtlValue((ControlHandle)iHandle));

	/*GetDItem(d,iWeapons,&iType,&iHandle, &iRect);
	i = GetCtlValue((ControlHandle)iHandle)-1;
	
	// File the last Weapon Value, to be sure.
	GetDItem(d,iWQty,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	WQty[i] = (short) num;*/

	for (i=0; i<15; i++) {
		WeapIn(id,i,(char)WQty[i]);
	}
	
	GetDItem(d,iForce,&iType,&iHandle, &iRect);
	ForceIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iFire,&iType,&iHandle, &iRect);
	FireIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iSnake,&iType,&iHandle, &iRect);
	SnakeIn(id,GetCtlValue((ControlHandle)iHandle));

	GetDItem(d,iKings,&iType,&iHandle, &iRect);
	KingsIn(id,GetCtlValue((ControlHandle)iHandle));
}

Boolean ValidateEditDialog(DialogPtr d)
{
	Str255 name,str;
	char tempname[kNamStrLen];
	short iType,i,j;
	Handle iHandle;
	Rect iRect;
	long num;
		
		
	GetDItem(d,iName,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	if (str[0] == 0) {
		BadName();
		GetDItem(d,iName,&iType,&iHandle, &iRect);
		SelIText(d,iName,0,32767);
		return(false);
	}
	
	GetDItem(d,iStr,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pStr","\p255") == 1) {
			GetDItem(d,iStr,&iType,&iHandle, &iRect);
			SelIText(d,iStr,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iDex,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pDex","\p255") == 1) {
			GetDItem(d,iDex,&iType,&iHandle, &iRect);
			SelIText(d,iDex,0,32767);
			return (false);
		}
	}

	GetDItem(d,iInt,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pInt","\p255") == 1) {
			GetDItem(d,iInt,&iType,&iHandle, &iRect);
			SelIText(d,iInt,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iWis,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pWis","\p255") == 1) {
			GetDItem(d,iWis,&iType,&iHandle, &iRect);
			SelIText(d,iWis,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iCurMP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pCurrent MP","\p255") == 1) {
			GetDItem(d,iCurMP,&iType,&iHandle, &iRect);
			SelIText(d,iCurMP,0,32767);
			return (false);
		}
	}

	GetDItem(d,iCurHP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 65535) {
		if (OutOfRange("\pCurrent HP","\p65535") == 1) {
			GetDItem(d,iCurHP,&iType,&iHandle, &iRect);
			SelIText(d,iCurHP,0,32767);
			return (false);
		}
	}

	GetDItem(d,iMaxHP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 65535) {
		if (OutOfRange("\pMax HP","\p65535") == 1) {
			GetDItem(d,iMaxHP,&iType,&iHandle, &iRect);
			SelIText(d,iMaxHP,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iXP,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 25599) {
		if (OutOfRange("\pXP","\p25599") == 1) {
			GetDItem(d,iXP,&iType,&iHandle, &iRect);
			SelIText(d,iXP,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iFood,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 25599) {
		if (OutOfRange("\pFood","\p25599") == 1) {
			GetDItem(d,iFood,&iType,&iHandle, &iRect);
			SelIText(d,iFood,0,32767);
			return (false);
		}
	}

	GetDItem(d,iGold,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 65535) {
		if (OutOfRange("\pGold","\p65535") == 1) {
			GetDItem(d,iGold,&iType,&iHandle, &iRect);
			SelIText(d,iGold,0,32767);
			return (false);
		}
	}
	
	GetDItem(d,iTorches,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pTorches","\p255") == 1) {
			GetDItem(d,iTorches,&iType,&iHandle, &iRect);
			SelIText(d,iTorches,0,32767);
			return (false);
		}
	}

	GetDItem(d,iGems,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pGems","\p255") == 1) {
			GetDItem(d,iGems,&iType,&iHandle, &iRect);
			SelIText(d,iGems,0,32767);
			return (false);
		}
	}

	GetDItem(d,iKeys,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pKeys","\p255") == 1) {
			GetDItem(d,iKeys,&iType,&iHandle, &iRect);
			SelIText(d,iKeys,0,32767);
			return (false);
		}
	}

	GetDItem(d,iPowders,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	if (num > 255) {
		if (OutOfRange("\pPowders","\p255") == 1) {
			GetDItem(d,iPowders,&iType,&iHandle, &iRect);
			SelIText(d,iPowders,0,32767);
			return (false);
		}
	}

	GetDItem(d,iArmor,&iType,&iHandle, &iRect);
	i = GetCtlValue((ControlHandle)iHandle)-1;
	
	// File the last Armor Value, to be sure.
	GetDItem(d,iAQty,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	AQty[i] = (short) num;

	j=0;
	for (i=0; i<7; i++) {
		if (AQty[i] > 255)  {
			j++;
		}
	}
	if (j) {
		if (OutOfRange("\pan armor type","\p255") == 1) return (false);
	}
	
	GetDItem(d,iWeapons,&iType,&iHandle, &iRect);
	i = GetCtlValue((ControlHandle)iHandle)-1;
	
	// File the last Weapon Value, to be sure.
	GetDItem(d,iWQty,&iType,&iHandle, &iRect);
	GetIText(iHandle,str);
	StringToNum(str,&num);
	WQty[i] = (short) num;
	
	j=0;
	for (i=0; i<15; i++) {
		if (WQty[i] > 255)  {
			j++;
		}
	}
	if (j) {
		if (OutOfRange("\pan armor type","\p255") == 1) return (false);
	}
	
	return (true);
}