/*
 * DSCH.h
 */

#ifndef __DSCH__
#define __DSCH__

struct DSCHEntry {
	char	offset,
			size,
			dataType,
			numericRep;
};
typedef struct DSCHEntry DSCHEntry;

// NOTE: numericRep stores a number of different things for different data types:
//		 Data Type			Meaning
//		 --------------------------
//		 Number				Numeric Representation (bin or exobin)
//		 String				<none>
//		 Category			Category ID
//		 BitMap				Bit
//		 ByteMap			<none>

//dataType
#define DSCHNumber		0
#define DSCHString		1
#define DSCHCategory	2
#define DSCHBitMap		3
#define DSCHByteMap		4

//	Number
#define kDSCHBinary		0
#define kDSCHExoBinary	1

//	Category
#define kDSCHHealth		0
#define kDSCHRace		1
#define kDSCHClass		2
#define kDSCHSex		3
#define kDSCHEqArm		4
#define kDSCHEqWeap		5

// BitMap
//  <direct value : no constants needed>


extern	DSCHEntry	gDSCHList[31];

OSErr LoadDSCHList(void);

#endif