/* 
 * Roster.c
 *
 * Reads and saves the Character Roster from the roster file.
 *
 * Version 1.1, 8/95
 *
 * Copyright  1995 by Michael D. Trent; all rights reserved.
 */
 
 #include "butil.h"
 #include "roster11.h"

unsigned char	gRoster[20][64];

OSErr LoadRoster(FSSpec *spec)
{
	short fRefNum,curResFile;
	OSErr err = noErr;
	Handle handle;
	
	// Find our App's Res File ID
	curResFile = CurResFile();
	
	// Open Roster's Res Fork
	fRefNum = FSpOpenResFile(spec, fsRdPerm);
	if (fRefNum == -1) goto bail;
	
	// Set Roster's Res Fork as our own
	UseResFile(fRefNum);
	if ((err = ResError()) != noErr) goto bail;
	
	// Get the Roster data
	handle = Get1Resource(kRosterType, kRosterID);
	if (!handle) goto bail;
	
	// Copy the Roster Resource into our local Roster array
	HLock(handle);
	
	bcopy((char *)(*handle),(char *)gRoster,kRosterSize);
	
	HUnlock(handle);
	
	// Reset Res File
	UseResFile(curResFile);
	//if ((err = ResError()) != noErr) goto bail;

bail:	// If an error occurs, jump here
	if (err == noErr) err = ResError();
	
	// Close the Roster File. Ignore any error from this
	CloseResFile(fRefNum);
	
	return err;
}

OSErr SaveRoster(FSSpec *spec)
{
	short fRefNum,curResFile;
	OSErr err = noErr;
	Handle handle;
	
	// Find our App's Res File ID
	curResFile = CurResFile();
	
	// Open Roster's Res Fork
	fRefNum = FSpOpenResFile(spec, fsWrPerm);
	if (fRefNum == -1) goto bail;
	
	// Set Roster's Res Fork as our own
	UseResFile(fRefNum);
	if ((err = ResError()) != noErr) goto bail;
	
	// Get the Roster resource
	handle = Get1Resource(kRosterType, kRosterID);
	if (!handle) goto bail;
	
	// Copy the local roster into the Roster Resource
	HLock(handle);
	
	bcopy((char *)gRoster,(char *)(*handle),kRosterSize);
	
	ChangedResource(handle);
	if ((err = ResError()) != noErr) goto bail;
	WriteResource(handle);
	if ((err = ResError()) != noErr) goto bail;
	
	HUnlock(handle);
	
	// Reset Res File
	UseResFile(curResFile);
	//if ((err = ResError()) != noErr) return err;

bail:
	if (err == noErr) err = ResError();

	// Close the Roster File
	CloseResFile(fRefNum);
	
	return err;
}